<script>
  // Dimensions
  const width = 600;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 30, left: 60 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Array
  const data = [
    { service: "Netflix", viewers: 2.9 },
    { service: "Amazon Prime Video", viewers: 1.3 },
    { service: "Disney+", viewers: 2.1 },
    { service: "Hulu", viewers: 0.9 },
    { service: "Apple TV", viewers: 1.1 },
    { service: "Rakuten", viewers: 0.4 }
  ];

  import {scaleLinear} from 'd3-scale';
  import {axisLeft, axisBottom} from 'd3-axis';
  import { select } from 'd3-selection';

  
  const scaley = scaleLinear().domain([0,3]).range([innerHeight,0]);
  const scalex = scaleLinear().domain([0,data.length]).range([0,innerWidth]);
  const axisx = axisBottom(scalex).ticks(data.length).tickFormat(function(d, i){return data[d]?.service;});
  const axisy = axisLeft(scaley).ticks();
  const xaxis = function(){
    return axisx(select('g.axisx'))
  };
  const yaxis = function(){return axisy(select('g.axisy'))}

</script>

<!-- setting a viewBox and max-width allows the SVG to shrink but not grow! -->
<svg viewbox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform={`translate(${margin.left},${margin.top})`}>
    <!--  -->
    <g transform="rotate(-90)" font-size="10" font-family="sans-serif" text-anchor="end">
      <text x="-100" y="-40" >Viewers (Million)</text>
    </g>

		{#each data as item, index}
    <rect x={scalex(index)} y={scaley(item.viewers)} 
          width={(innerWidth/data.length)-30} height={height-scaley(item.viewers)-margin.top-margin.bottom} 
          fill="steelblue" />
		{/each}
  </g>

	<g class='axisy' transform={`translate(53,${margin.top})`} use:xaxis></g>
	<g class='axisx' transform={`translate(${(innerWidth/data.length)},${height-margin.bottom})`}  use:yaxis></g>
</svg>
